*+--------------------------------------------------------------------
*+
*+ Source Module => d:\ALASKA\PFWHEEL\\PWHEEL.PRG
*+
*+    Copyright(C) 1983-2021 by Auge & Ohr
*+
*+    Functions: Procedure AppSys()
*+               Procedure Main()
*+               Function scrollVertical()
*+               Function scrollInner()
*+               Function ShowProgress()
*+               Function BMP2BMP()
*+
*+    Reformatted by Click! 2.05.38 on Oct-5-2021 at  8:07 am
*+
*+--------------------------------------------------------------------

#include "Xbp.ch"
#include "AppEvent.ch"
#include "Gra.ch"
#include "common.ch"

#include "PWCLASS.CH"

*+--------------------------------------------------------------------
*+
*+    Procedure AppSys()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE AppSys

RETURN

*+--------------------------------------------------------------------
*+
*+    Procedure Main()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE Main

LOCAL nEvent, mp1, mp2, oXbp
LOCAL oDlg, oPgWheel, oSrollbar, oPW0, oPW1, oPW2, oPW3, oInner, oBMP
LOCAL oThread1, oThread2, oThread3

   oBMP := XbpBitmap() :new() :create()
   oBMP:Load(, 1000 )

   SET ALTER TO "_LOG.TXT"
   SET ALTER ON

   oDlg := XbpDialog() :new( AppDesktop(),, { 0, 0 }, { 600, 480 } )
   oDlg:title := "ProgressWheel " + cVersion
   oDlg:titlebar := .T.
   oDlg:tasklist := .T.
   oDlg:icon := 1
   oDlg:drawingArea:ClipChildren := .T.
*   oDlg:drawingarea:bitmap := BMP2BMP( oBMP, { 600, 480 } )
   oDlg:create()

   CenterControl( oDlg )
*   oDlg:DrawingArea:setColorBG( GRA_CLR_PINK )

   // *************************** change %       ****************************

   oPgWheel := DXE_ProgressWheel() :New( oDlg:DrawingArea,, { 10, 50 }, { 200, 200 } )
   //    oPgWheel:aCenter := {100,100}
   //    oPgWheel:nRadius := 100
   //    oPgWheel:nInner  := 50
   //    oPgWheel:cInnerColor := GRA_CLR_YELLOW
   //    oPgWheel:aEllipse := { 1, 0, 0, 1 }
   //    oPgWheel:nStartAngle := -90
   //    oPgWheel:nSweepAngle := -180
   //    oPgWheel:lShowPercent := .T.
   //    oPgWheel:cFont := "Arial"
   //    oPgWheel:lArea := .T.             // Inner Line Color same or BLACK
   oPgWheel:cColor := GRA_CLR_BLUE
   oPgWheel:drawMode := XBP_DRAW_OWNER
   oPgWheel:draw := { | oPS, aInfo, oSelf | oSelf:Draw( oPS, aInfo, oSelf ) }
   oPgWheel:Create()
   oPgWheel:SetPercent( 50 )

   oSrollbar := XbpScrollbar() :new( oDlg:DrawingArea,, { 10, 10 }, { 198, 40 } )
   oSrollbar:type := XBPSCROLL_HORIZONTAL
   oSrollbar:range := { 0, 100 }
   oSrollbar:create()
   oSrollbar:scroll := { | mp1, uNIL, oSelf | scrollVertical( mp1[ 1 ], mp1[ 2 ], oSelf, oPgWheel ) }
   oSrollbar:setData( 50 )

   // *************************** Inner Circle   ****************************

   oPW0 := DXE_ProgressWheel() :New( oDlg:DrawingArea,, { 210, 50 }, { 200, 200 } )
   oPW0:cColor := GRA_CLR_BLUE
   oPW0:cInnerColor := GRA_CLR_GREEN
   oPW0:drawMode := XBP_DRAW_OWNER
   oPW0:draw := { | oPS, aInfo, oSelf | oSelf:Draw( oPS, aInfo, oSelf ) }
   oPW0:Create()
   oPW0:SetPercent( 100 )

   oInner := XbpScrollbar() :new( oDlg:DrawingArea,, { 212, 10 }, { 198, 40 } )
   oInner:type := XBPSCROLL_HORIZONTAL
   oInner:range := { 0, 100 }
   oInner:create()
   oInner:scroll := { | mp1, uNIL, oSelf | scrollInner( mp1[ 1 ], mp1[ 2 ], oSelf, oPW0 ) }
   oInner:setData( 50 )

   // *************************** more Sample    ****************************

   oPW1 := DXE_ProgressWheel() :New( oDlg:DrawingArea,, { 420, 50 }, { 100, 100 } )
   oPW1:cColor := GRA_CLR_RED
   oPW1:cInnerColor := GRA_CLR_CYAN // XBPSYSCLR_TRANSPARENT                          // not working ...
   oPW1:drawMode := XBP_DRAW_OWNER
   oPW1:draw := { | oPS, aInfo, oSelf | oSelf:Draw( oPS, aInfo, oSelf ) }
   oPW1:lShowPercent := .T.
   oPW1:Create()
   oPW1:SetPercent( 0 )

   oPW2 := DXE_ProgressWheel() :New( oDlg:DrawingArea,, { 420, 152 }, { 100, 100 } )
   oPW2:cColor := GRA_CLR_GREEN
   oPW2:nInner := 33
   oPW2:cInnerColor := GRA_CLR_YELLOW
   oPW2:drawMode := XBP_DRAW_OWNER
   oPW2:draw := { | oPS, aInfo, oSelf | oSelf:Draw( oPS, aInfo, oSelf ) }
   oPW2:Create()
   oPW2:SetPercent( 0 )

   oPW3 := DXE_ProgressWheel() :New( oDlg:DrawingArea,, { 520, 50 }, { 32, 32 } )
   oPW3:cColor := GRA_CLR_CYAN
   oPW3:nInner := 6
   oPW3:cInnerColor := GRA_CLR_PINK
   oPW3:drawMode := XBP_DRAW_OWNER
   oPW3:draw := { | oPS, aInfo, oSelf | oSelf:Draw( oPS, aInfo, oSelf ) }
   oPW3:lShowPercent := .F.
   //    oPW3:cFont := "Fixedsys"
   oPW3:Create()
   oPW3:SetPercent( 0 )

   // *************************** start Threads  ****************************

   oThread1 := Thread() :new()
   oThread1:setInterval( 1000 )
   oThread1:start( "ShowProgress", oPW1, 50 )

   oThread2 := Thread() :new()
   oThread2:setInterval( 1000 )
   oThread2:start( "ShowProgress", oPW2, 50 )

   oThread3 := Thread() :new()
   oThread3:setInterval( 1000 )
   oThread3:start( "ShowProgress", oPW3, 50 )

   SetAppFocus( oPW0 )

   nEvent := xbe_None
   DO WHILE nEvent != xbeP_Close .AND. nEvent != xbeK_ESC
      nEvent := AppEvent( @mp1, @mp2, @oXbp, 10 )

      IF nEvent != xbeP_None .AND. oXbp != NIL
         oXbp:handleEvent( nEvent, mp1, mp2 )
      ENDIF
   ENDDO

   SET ALTER OFF
   SET ALTER TO

   oThread1:SetInterval( NIL )
   oThread2:SetInterval( NIL )
   oThread3:SetInterval( NIL )

   oThread1 := NIL
   oThread2 := NIL
   oThread3 := NIL

   oPgWheel:Destroy()
   oPW0:Destroy()
   oPW1:Destroy()
   oPW2:Destroy()
   oPW3:Destroy()

RETURN

*+--------------------------------------------------------------------
*+
*+    Function scrollVertical()
*+
*+    Called from ( pwheel.prg )   1 - procedure main()
*+
*+--------------------------------------------------------------------
*+
FUNCTION scrollVertical( nScrlPos, nCommand, oSrollbar, oPgWheel )

LOCAL nPosi := oSrollbar:getData()

   oPgWheel:SetPercent( nPosi )
   oPgWheel:invalidateRect()

   // ****************************************************
   //    DO CASE
   //    CASE nCommand == XBPSB_PREVPOS
   // *        SKIP -1
   //    CASE nCommand == XBPSB_NEXTPOS
   // *        SKIP  1
   //    CASE nCommand == XBPSB_PREVPAGE
   // *        GOTO nScrlPos
   //    CASE nCommand == XBPSB_NEXTPAGE
   // *        GOTO nScrlPos
   //    CASE nCommand == XBPSB_SLIDERTRACK
   // *        // Nichts
   //    CASE nCommand == XBPSB_ENDTRACK
   // *        GOTO nScrlPos
   //       oPgWheel:SetAngle( nPosi )
   //
   //    CASE nCommand == XBPSB_ENDSCROLL
   // *        GOTO nScrlPos
   //       oPgWheel:SetAngle( nPosi )
   //    ENDCASE
   // ****************************************************

RETURN nil

*+--------------------------------------------------------------------
*+
*+    Function scrollInner()
*+
*+    Called from ( pwheel.prg )   1 - procedure main()
*+
*+--------------------------------------------------------------------
*+
FUNCTION scrollInner( nScrlPos, nCommand, oSrollbar, oPgWheel )

LOCAL nPosi := oSrollbar:getData()

   oPgWheel:SetInner( nPosi )
   oPgWheel:invalidateRect()
RETURN nil

*+--------------------------------------------------------------------
*+
*+    Function ShowProgress()
*+
*+--------------------------------------------------------------------
*+
FUNCTION ShowProgress( oPW, nTime )

LOCAL i := 0
   oPW:SetPercent( 0 )
   FOR i := 1 TO 100
      //       oPW:SetPercent( i )
      oPW:Increment()
      SLEEP( nTime )
   NEXT
RETURN nil

*+--------------------------------------------------------------------
*+
*+    Function BMP2BMP()
*+
*+    Called from ( pwheel.prg )   1 - procedure main()
*+
*+--------------------------------------------------------------------
*+
FUNCTION BMP2BMP( oBMP, aXbpSize )

LOCAL oHuge
LOCAL oTiny
LOCAL oPS
LOCAL oRet
LOCAL nBits
LOCAL nPlanes

   IF aXbpSize[ 2 ] > 0
      oHuge := oBMP
      nBits := oBMP:bits
      nPlanes := oBMP:planes

      oPS := XBPPRESSPACE() :new() :Create()
      //Create a small bitmap to fit in our XbpStatic
      oTiny := XBPBITMAP() :New() :Create()
      IF nBits > 1 .OR. nPlanes > 1
         oTiny:Make( aXbpSize[ 1 ], aXbpSize[ 2 ], nPlanes, nBits )
      ELSE
         oTiny:Make( aXbpSize[ 1 ], aXbpSize[ 2 ] )
      ENDIF
      oTiny:presSpace( oPS )
      //Copie and resize the huge bitmap to the small bitmap
      oHuge:Draw( oPS, { 0, 0, aXbpSize[ 1 ], aXbpSize[ 2 ] },,, GRA_BLT_BBO_IGNORE )
      //      oHuge:Draw( oPS, { 0, 0, aXbpSize[1], aXbpSize[2] },,,GRA_BLT_ROP_SRCCOPY )
      oRet := oTiny
   ELSE
      oRet := oBMP
   ENDIF

RETURN oRet

//
//
//

*+ EOF: PWHEEL.PRG